# ELogging log4j library

This library contains the following plugins:

## ELJsonLayout

### Overview

This is a Yet Another log4j2 json layout which has a couple advantages over the other ones out there:

This library has been created specifically to be used in mule 4 applications, because all the other json layouts I tried didn't work for one reason or another.

Tt supports MapMessage to generate a json message with multiples attributes. Additionally when using a MapMessage,
you can specify that a value in the message map should be included as "raw json" by adding another key/value with the
same key appended with "\_$\_rawjson\_$\_", with the value of "true"

so for example the following key/values:

```
foo=bar
obj={}
```

would generate:

```
{
    ...
    "foo": "bar",
    "obj": "{}"
}
```

but if instead you specify

```
foo=bar
obj={}
obj_$_rawjson_$_=true
```

it would generate:

```
{
    ...
    "foo": "bar",
    "obj": {}
}
```

### Example configuration

```
<?xml version="1.0" encoding="utf-8"?>
<Configuration>
    <Appenders>
        <RollingFile name="file" fileName="mytest.log" 
                 filePattern="mytest-%i.log">
            <ELJsonLayout/>
            <SizeBasedTriggeringPolicy size="10 MB" />
            <DefaultRolloverStrategy max="10"/>
        </RollingFile>
    </Appenders>
    <Loggers>
        <AsyncRoot level="INFO">
            <AppenderRef ref="file" />
        </AsyncRoot>
    </Loggers>
</Configuration>
```

In some cases with complex classloading (ie. mule applications) you might have to specify the package

```xml
<Configuration packages="com.aeontronix.elogging.log4j2">
```

## ELMemoryAppender

This appender just store each formatted log entry in memory
